package org.greenstone.gsdl3.gs3build.doctypes;

import java.io.*;
import java.net.*;

import org.greenstone.gsdl3.gs3build.metadata.*;

public class IndexRecogniser implements RecogniserInterface
{
  DocumentList listRepository;

  public IndexRecogniser(DocumentList listRepository)
  { this.listRepository = listRepository;
  }

  public boolean parseDocument(METSFile file)
  {
    String MIMEType = file.getMIMEType();
    if (MIMEType == null || 
	MIMEType.equals("text/plain")) {
      URL location = file.getLocation();
      return this.parseDocument(location);
    }
    return false;
  }

  public boolean parseDocument(URL url)
  { String fileName = null;

    if (url.getProtocol().equals("file"))
    { fileName = url.getPath();
    }
    
    if (fileName != null) {
      String leafName;
      int leafAt = fileName.lastIndexOf(File.separator);
      if (leafAt >= 0) {
	leafName = fileName.substring(leafAt+1);
      }
      else {
	leafName = fileName;
      }

      if (leafName.equals("index.txt"))
      {	
	System.out.println("Posting Index Document " + fileName);
	IndexDocument doc = new IndexDocument(url);
	this.listRepository.addDocument(doc);
	// TODO: spawn knowledge of children too...
	//				System.out.println(doc.getDocumentText());
	return true;
      }
    }
    else {
      // TODO: get Mime type remotely, and then proceed if required
    }
    return false;
  }
}
